searchNodes=[{"ref":"Uploadex.html","title":"Uploadex","type":"module","doc":"Context Helper functions for handling files."},{"ref":"Uploadex.html#create_with_file/2","title":"Uploadex.create_with_file/2","type":"function","doc":"Inserts the changeset and store the record files in a database transaction, so if the files fail to be stored the record will not be created."},{"ref":"Uploadex.html#delete_with_file/2","title":"Uploadex.delete_with_file/2","type":"function","doc":"Deletes the record and all of its files. This is not in a database transaction, since the delete operation never returns errors."},{"ref":"Uploadex.html#update_with_file/3","title":"Uploadex.update_with_file/3","type":"function","doc":"Updates the record and its files in a database transaction, so if the files fail to be stored the record will not be created. This function also deletes files that are no longer referenced."},{"ref":"Uploadex.html#update_with_file_keep_previous/2","title":"Uploadex.update_with_file_keep_previous/2","type":"function","doc":"Similar to update_with_file/3, but does not delete previous files."},{"ref":"Uploadex.FileProcessing.html","title":"Uploadex.FileProcessing","type":"module","doc":"Process files in Base64"},{"ref":"Uploadex.FileProcessing.html#process_base64/1","title":"Uploadex.FileProcessing.process_base64/1","type":"function","doc":"This function currently only supports binaries in base 64 because it&#39;s not clear what are the other use cases for this."},{"ref":"Uploadex.FileStorage.html","title":"Uploadex.FileStorage","type":"module","doc":"Storage for Local Files. Opts directory: String (required for all functions) - Relative to base_path base_path: String (required for all functions) base_url: String (required for Uploadex.Storage.get_url/2) To build the URL, base_path will be replaced by base_url. Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts(Uploadex.FileStorage), do: [base_path: :code.priv_dir(:my_app), base_url: Endpoint.url()] def storage(%User{} = user), do: {Uploadex.FileStorage, directory: &quot;/uploads/users&quot;}"},{"ref":"Uploadex.Files.html","title":"Uploadex.Files","type":"module","doc":"Functions to store and delete files."},{"ref":"Uploadex.Files.html#delete_files/1","title":"Uploadex.Files.delete_files/1","type":"function","doc":"Deletes all files for a record."},{"ref":"Uploadex.Files.html#delete_previous_files/2","title":"Uploadex.Files.delete_previous_files/2","type":"function","doc":"Deletes all files that changed."},{"ref":"Uploadex.Files.html#get_file_url/1","title":"Uploadex.Files.get_file_url/1","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_file_url/2","title":"Uploadex.Files.get_file_url/2","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_files_url/1","title":"Uploadex.Files.get_files_url/1","type":"function","doc":""},{"ref":"Uploadex.Files.html#get_files_url/2","title":"Uploadex.Files.get_files_url/2","type":"function","doc":""},{"ref":"Uploadex.Files.html#store_files/1","title":"Uploadex.Files.store_files/1","type":"function","doc":"Stores all files of a record, as defined by the uploader. Files that are not maps are ignored, which allows for assigning an existing file to a record without recreating it, by simply passing it&#39;s filename."},{"ref":"Uploadex.Files.html#t:record/0","title":"Uploadex.Files.record/0","type":"type","doc":""},{"ref":"Uploadex.Resolver.html","title":"Uploadex.Resolver","type":"module","doc":"Resolver functions to make it easier to use Uploadex with Absinthe. Example In your Absinthe schema, assuming user only has one photo: object :user do field :photo_url, :string, resolve: &amp;Uploadex.Resolver.get_file_url/3 end If it has many photos: object :user do field :photos, list_of(:string), resolve: &amp;Uploadex.Resolver.get_files_url/3 end If an object has many files but the field is for a specific one: object :company do field :logo_url, :string, resolve: fn company, _, _ -&gt; Uploadex.Resolver.get_file_url(company, company.logo) end end"},{"ref":"Uploadex.Resolver.html#get_file_url/2","title":"Uploadex.Resolver.get_file_url/2","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_file_url/3","title":"Uploadex.Resolver.get_file_url/3","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_files_url/2","title":"Uploadex.Resolver.get_files_url/2","type":"function","doc":""},{"ref":"Uploadex.Resolver.html#get_files_url/3","title":"Uploadex.Resolver.get_files_url/3","type":"function","doc":""},{"ref":"Uploadex.S3Storage.html","title":"Uploadex.S3Storage","type":"module","doc":"Storage for AWS S3. Opts bucket: String (required for Uploadex.Storage.store/2 and Uploadex.Storage.delete/2) directory: String (required for all functions) upload_opts: Keyword list. This opts are passed to ExAws.S3.upload/4 and ExAws.S3.put_object/4 (required for Uploadex.Storage.store/2) base_url: String (required for Uploadex.Storage.get_url/2) Example To use this storage for your User record, define these functions in your Uploadex.Uploader implementation: def default_opts(Uploadex.S3Storage), do: [bucket: &quot;my_bucket&quot;, base_url: &quot;https://my_bucket.s3-sa-east-1.amazonaws.com&quot;, upload_opts: [acl: :public_read]] def storage(%User{} = user), do: {Uploadex.S3Storage, directory: &quot;/photos&quot;}"},{"ref":"Uploadex.Storage.html","title":"Uploadex.Storage","type":"behaviour","doc":"Behaviour for a Storage implementation."},{"ref":"Uploadex.Storage.html#c:delete/2","title":"Uploadex.Storage.delete/2","type":"callback","doc":"Deletes the file"},{"ref":"Uploadex.Storage.html#c:get_url/2","title":"Uploadex.Storage.get_url/2","type":"callback","doc":"Returns the file&#39;s URL"},{"ref":"Uploadex.Storage.html#c:store/2","title":"Uploadex.Storage.store/2","type":"callback","doc":"Stores the file"},{"ref":"Uploadex.Storage.html#t:file/0","title":"Uploadex.Storage.file/0","type":"type","doc":""},{"ref":"Uploadex.Storage.html#t:opts/0","title":"Uploadex.Storage.opts/0","type":"type","doc":""},{"ref":"Uploadex.Storage.html#t:record/0","title":"Uploadex.Storage.record/0","type":"type","doc":""},{"ref":"Uploadex.TestStorage.html","title":"Uploadex.TestStorage","type":"module","doc":"Storage for tests. See files_test.exs for examples on how to use this."},{"ref":"Uploadex.TestStorage.html#child_spec/1","title":"Uploadex.TestStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Uploadex.TestStorage.html#get_deleted/0","title":"Uploadex.TestStorage.get_deleted/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#get_opts/0","title":"Uploadex.TestStorage.get_opts/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#get_stored/0","title":"Uploadex.TestStorage.get_stored/0","type":"function","doc":""},{"ref":"Uploadex.TestStorage.html#start_link/1","title":"Uploadex.TestStorage.start_link/1","type":"function","doc":""},{"ref":"Uploadex.Upload.html","title":"Uploadex.Upload","type":"module","doc":"Ecto type that handles upload. It stores the filename in the database."},{"ref":"Uploadex.Upload.html#cast/1","title":"Uploadex.Upload.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Uploadex.Upload.html#dump/1","title":"Uploadex.Upload.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Uploadex.Upload.html#load/1","title":"Uploadex.Upload.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Uploadex.Upload.html#type/0","title":"Uploadex.Upload.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Uploadex.Upload.html#t:upload_binary/0","title":"Uploadex.Upload.upload_binary/0","type":"type","doc":""},{"ref":"Uploadex.Upload.html#t:upload_path/0","title":"Uploadex.Upload.upload_path/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html","title":"Uploadex.Uploader","type":"behaviour","doc":"Behaviour of an Uploader. Example defmodule MyApp.Uploader do @moduledoc false @behaviour Uploadex.Uploader alias MyAppWeb.Endpoint @impl true def get_files(%User{photo: photo}), do: photo def get_files(%Company{photo: photo}), do: photo @impl true def default_opts(Uploadex.FileStorage), do: [base_path: :code.priv_dir(:my_app), base_url: Endpoint.url()] def default_opts(Uploadex.S3Storage), do: [bucket: &quot;my_bucket&quot;, base_url: &quot;https://my_bucket.s3-sa-east-1.amazonaws.com&quot;, upload_opts: [acl: :public_read]] @impl true def storage(%User{} = user), do: {Uploadex.FileStorage, directory: storage_dir(user)} def storage(%Company{} = company), do: {Uploadex.S3Storage, directory: storage_dir(company)} def storage_dir(%User{id: user_id}), do: &quot;/uploads/users/\#{user_id}&quot; def storage_dir(%Company{}), do: &quot;/thumbnails&quot; end"},{"ref":"Uploadex.Uploader.html#c:default_opts/1","title":"Uploadex.Uploader.default_opts/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:get_files/1","title":"Uploadex.Uploader.get_files/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:storage/1","title":"Uploadex.Uploader.storage/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#t:file/0","title":"Uploadex.Uploader.file/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html#t:record/0","title":"Uploadex.Uploader.record/0","type":"type","doc":""}]